// Boucle de Langton | Mattias EYHERABIDE

final int TAILLE_PLATEAU = 140;
final int TAILLE_AUTOMATE = 5;
final boolean OFFLINE = true;

Cellule[][] matrice;

int ratioTaille = 1;
int nbIterations = 0;
int courrant = 0;

/*int[][] boucle = {
  {0,2,2,2,2,2,2,2,2,0,0,0,0,0,0},
  {2,1,7,0,1,4,0,1,4,2,0,0,0,0,0},
  {2,0,2,2,2,2,2,2,0,2,0,0,0,0,0},
  {2,7,2,0,0,0,0,2,1,2,0,0,0,0,0},
  {2,1,2,0,0,0,0,2,1,2,0,0,0,0,0},
  {2,0,2,0,0,0,0,2,1,2,0,0,0,0,0},
  {2,7,2,0,0,0,0,2,1,2,0,0,0,0,0},
  {2,1,2,2,2,2,2,2,1,2,2,2,2,2,0},
  {2,0,7,1,0,7,1,0,7,1,1,1,1,1,2},
  {0,2,2,2,2,2,2,2,2,2,2,2,2,2,0}
};*/


Regles regles;

void settings(){
	size(TAILLE_PLATEAU * TAILLE_AUTOMATE * ratioTaille, TAILLE_PLATEAU * TAILLE_AUTOMATE * ratioTaille);
}

void setup(){
	matrice = new Cellule[TAILLE_PLATEAU][TAILLE_PLATEAU];
	for(int i = 0; i < TAILLE_PLATEAU; i++)
		for(int j = 0; j < TAILLE_PLATEAU; j++)
			matrice[i][j] = new Cellule(0);
  
  if (!OFFLINE) {
    regles = new Regles("https://git.litislab.fr/dolivier/VieArtificielle/-/wikis/fichiers/langtonloop.txt");
  } else { regles = new Regles("./RèglesLangton.txt"); }
	

	initCells();
}

void initCells(){
  int i, j;
	int centre = TAILLE_PLATEAU/2;
	String[] lines = loadStrings("boucleInitialeLangton.txt");
	i= j = centre;
	for(String line : lines){
		String[] states = line.split(" "); //Ajout d'un espace entre les états
		for(int k = 0; k < states.length; k++)
			matrice[i][(j + k) % TAILLE_PLATEAU] = new Cellule(int(states[k]));
      i++;
		  i = i % TAILLE_PLATEAU;
	}
}

void draw(){

	for(int i = 0; i < TAILLE_PLATEAU; i++){
		for(int j = 0; j < TAILLE_PLATEAU; j++){

			int cell = matrice[i][j].getEtat();

      switch(cell){
       case 0 : fill(51,51,50); break;
       case 1 : fill(1,17,255); break;
       case 2 : fill(254,26,1); break;
       case 4 : fill(254,246,21); break;
       case 7 : fill(0,216,254); break;
      }

			float x = j * TAILLE_AUTOMATE;
			float y = i * TAILLE_AUTOMATE;
			rect(x, y, TAILLE_AUTOMATE, TAILLE_AUTOMATE);

			matrice[i][j].setEtat(getEtatSuivant(i, j, cell));
		}
	}
	courrant = ++courrant % 2;

  textSize(25);
  fill(255);
  text("Itérations : " + ++nbIterations, 10, 20);  

}

int getEtatSuivant(int i, int j, int c){
  
	int n, e, s, w;
  
  if ( (i + 1) < TAILLE_PLATEAU && (j + 1) < TAILLE_PLATEAU ) {
    n = matrice[Math.floorMod(i-1, TAILLE_PLATEAU)][j].getEtat();
    e = matrice[i][(j + 1) % TAILLE_PLATEAU].getEtat();
    s = matrice[(i + 1) % TAILLE_PLATEAU][j].getEtat();
    w = matrice[i][Math.floorMod(j-1, TAILLE_PLATEAU)].getEtat();
    
	  return regles.correspond(new int[]{c, n, e, s, w});
  }
  
  return 0;
}


class Cellule{

  private int[] etatActuel;

  public Cellule(int state){
    etatActuel = new int[]{state, 0};
  }

  public int getEtat(){
    return etatActuel[courrant];
  }
  
  public void setEtat(int etat){
    etatActuel[(courrant + 1) % 2] = etat;
  }
}
